#include "common.hpp"

using dtl::Diff;

int main(int, char **) {

  int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  int b[] = {3, 5, 1, 4, 5, 1, 7, 9, 6, 10};
  int asiz = sizeof(a) / sizeof(int);
  int bsiz = sizeof(b) / sizeof(int);
  for (int i = 0; i < asiz; ++i) {
    std::cout << a[i] << " ";
  }
  std::cout << std::endl;
  for (int i = 0; i < bsiz; ++i) {
    std::cout << b[i] << " ";
  }
  std::cout << std::endl;

  typedef int elem;
  typedef std::vector<int> sequence;

  sequence A(&a[0], &a[asiz]);
  sequence B(&b[0], &b[bsiz]);
  Diff<elem> d(A, B);
  d.compose();

  // editDistance
  std::cout << "editDistance:" << d.getEditDistance() << std::endl;

  // Longest Common Subsequence
  sequence lcs_v = d.getLcsVec();
  std::cout << "LCS: ";
  for (sequence::iterator vit = lcs_v.begin(); vit != lcs_v.end(); ++vit) {
    std::cout << *vit << " ";
  }
  std::cout << std::endl;

  // Shortest Edit Script
  std::cout << "SES" << std::endl;
  d.printSES();

  return 0;
}
