#include "common.hpp"

using namespace dtl;

int main(int argc, char *argv[]) {

  if (isFewArgs(argc, 2)) {
    std::cerr << "Too few arguments." << std::endl;
    return -1;
  }

  typedef std::string elem;
  typedef std::vector<string> sequence;

  std::string s(argv[1]);

  if (!isFileExist(s)) {
    std::cerr << s << " is invalid." << std::endl;
    return -1;
  }

  std::ifstream fs(s.c_str());
  const Ses<elem> ses =
      Diff<elem, sequence>::composeSesFromStream<std::ifstream>(fs);
  dtl::Diff<elem, sequence>::printSES(ses);

  return 0;
}
