#include "common.hpp"

using dtl::Diff;

int main(int argc, char *argv[]) {

  if (isFewArgs(argc)) {
    std::cerr << "Too few arguments." << std::endl;
    return -1;
  }

  typedef char elem;
  typedef std::string sequence;

  sequence A(argv[1]);
  sequence B(argv[2]);

  Diff<elem, sequence> d(A, B);
  // d.onOnlyEditDistance();
  d.compose();

  // editDistance
  std::cout << "editDistance:" << d.getEditDistance() << std::endl;

  // Longest Common Subsequence
  std::vector<elem> lcs_v = d.getLcsVec();
  sequence lcs_s(lcs_v.begin(), lcs_v.end());
  std::cout << "LCS:" << lcs_s << std::endl;

  // Shortest Edit Script
  std::cout << "SES" << std::endl;
  d.printSES();

  return 0;
}
