#include "common.hpp"

using dtl::Diff3;

int main(int argc, char *argv[]) {

  if (isFewArgs(argc, 4)) {
    std::cerr << "Too few arguments." << std::endl;
    return -1;
  }

  typedef char elem;
  typedef std::string sequence;

  sequence A(argv[1]);
  sequence B(argv[2]);
  sequence C(argv[3]);

  Diff3<elem, sequence> diff3(A, B, C);
  diff3.compose();
  if (!diff3.merge()) {
    std::cerr << "conflict." << std::endl;
    return 0;
  }
  std::cout << "result:" << diff3.getMergedSequence() << std::endl;

  return 0;
}
