#include "common.hpp"

#include "printers.hpp"

using dtl::Diff;

int main(int argc, char *argv[]) {

  if (isFewArgs(argc)) {
    std::cerr << "Too few arguments." << std::endl;
    return -1;
  }

  typedef char elem;
  typedef std::string sequence;

  sequence A(argv[1]);
  sequence B(argv[2]);

  Diff<elem, sequence> d(A, B);
  d.compose();

  // Shortest Edit Script
  std::cout << "SES" << std::endl;

  d.printSES<std::ostream, customChangePrinter>(std::cout);

  return 0;
}
